#include <bits/stdc++.h>
using namespace std;

int provera1(int n, long long a[], long long x, long long modul)
{
    for(int i=1; i<n; i++)
    {
        if(((a[i]-a[i-1])%x)!=0)
        {
            return 0;
        }        
    }
    return 1;
}

int provera2(int m, long long b[], long long x, long long modul)
{
    for(int i=0; i<m; i++)
    {
        if(b[i]%x==modul)return 0;
    }
    return 1;
}

int main()
{
    int t;
    cin>>t;
    int n, m;
    long long x, modul;
    int k;
    for(int l=0; l<t; l++)
    {
        cin>>n>>m;
        long long a[n], b[m];
        for(int i=0; i<n; i++)
        {
            cin>>a[i];
        }
        sort(a, a+n);
        for(int i=0; i<m; i++)
        {
            cin>>b[i];
        }
        long long niz[n-1];
        niz[0]=a[1]-a[0];
        x=niz[0];
        for(int i=1; i<n-1; i++)
        {
            niz[i]= a[i+1]-a[i];
            if(niz[i]<x)x=niz[i];
        }
        modul=a[0]%x;
        k=provera1(n, a, x, modul);
        if(k==0)
        {
            cout<<k<<endl;
            continue;
        }
        k=provera2(m, b, x, modul);
        if(k==0)
        {
            cout<<k<<endl;
            continue;
        }
        cout<<1<<endl;
    }
    return 0;
}